// Martin Goettlich @ DESY
// 08/10/2004

#include "H1CintSteer.h"

using namespace std;

ClassImp(H1CintSteer)

H1CintSteer::H1CintSteer(const char* filename)
{
  int state;
  state=G__init_cint("Cint");
  switch(state) {
  case G__INIT_CINT_SUCCESS_MAIN:
    break;
  case G__INIT_CINT_SUCCESS:
    state=G__loadfile(filename);
    if(state==G__LOADFILE_SUCCESS) {

      cout<<"<== H1CintSteer ==> File '"<<filename<<"' opened for reading..."<<endl;

    }
    break;
  case G__INIT_CINT_FAILURE:
  default:
    cerr<<"Initialization of Cint failed.\n"<<endl;
  }
}

H1CintSteer::~H1CintSteer()
{
  G__scratch_all(); // terminate cint and make memory leak check work
}

Int_t H1CintSteer::GetInt(char* name)
{
  void* ptr = this->GetPtr(name,"int");
  if(ptr) {
    int* var = (int*) ptr;
    return *var;
  }
  return 0;
}

Float_t H1CintSteer::GetFloat(char* name)
{
  void* ptr = this->GetPtr(name,"float");
  if(ptr) {
    float* var = (float*) ptr;
    return *var;
  }
  return 0;
}

Double_t H1CintSteer::GetDouble(char* name)
{
  void* ptr = this->GetPtr(name,"double");
  if(ptr) {
    double* var = (double*) ptr;
    return *var;
  }
  return 0;
}

TString H1CintSteer::GetString(char* name)
{
  void* ptr = this->GetPtr(name,"struct TString");
  if(ptr) {
    TString* var = (TString*) ptr;
    return *var;
  }
  return "Variable not found or wrong type!";
}

void* H1CintSteer::GetPtr(char* name, char* type)
{
  void* ptr;
  char mytype[100];
  ptr = (void*) G__what_type(name,mytype,0,0);
 
  if(strncmp("NULL",mytype,strlen(name))==0) {
    cout<<"<== H1CintSteer ==> Variable '"<<name<<"' is not defined!"<<endl;
    return NULL;
  }

  if(strncmp(type,mytype,strlen(type))==0) {
    cout<<"<== H1CintSteer ==> Reading of variable '"<<name<<"' of type '"<<type<<"' successful!"<<endl;
  } else {
    cout<<"<== H1CintSteer ==> Variable '"<<name<<"' is not defined as '"<<type<<"'! It is of type ' "<<mytype<<"'!"<<endl;
    return NULL;
  }

  return ptr;
}

void H1CintSteer::CallFunction(const char* funcname)
{ 
  G__calc("func();");
}

